//
// Copyright (c) 2012, MindFusion LLC - Bulgaria.
//

using System;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace MindFusion.Diagramming.WinForms.Samples.CS.LogicGates
{
	using Convert = System.Convert;

	/// <summary>
	/// Summary description for ResultForm.
	/// </summary>
	public partial class ResultForm : Form
	{
		public ResultForm()
		{
			InitializeComponent();
		}

		private void FormResult_Load(object sender, System.EventArgs e)
		{
			myPoint[0] = new PointF(0, 20);
			myPoint[1] = new PointF(0, 60);
			myPoint[2] = new PointF(0, 100);
			myPoint[3] = new PointF(0, 140);
			myPoint[4] = new PointF(0, 180);
			myPoint[5] = new PointF(0, 220);
			myPoint[9] = new PointF(0, 260);
			myPoint[6] = new PointF(0, 300);
			myPoint[7] = new PointF(0, 340);
			myPoint[8] = new PointF(0, 380);
			myPoint[9] = new PointF(0, 410);

			PointLoc[0] = new PointF(50, 15);
			PointLoc[1] = new PointF(50, 55);
			PointLoc[2] = new PointF(50, 95);
			PointLoc[3] = new PointF(50, 135);
			PointLoc[4] = new PointF(50, 175);
			PointLoc[5] = new PointF(50, 215);
			PointLoc[6] = new PointF(50, 255);
			PointLoc[7] = new PointF(50, 295);
			PointLoc[8] = new PointF(50, 335);
			PointLoc[9] = new PointF(50, 375);
			PointLoc[10] = new PointF(50, 405);

			InputsNames[0] = "Input A";
			InputsNames[1] = "Input B";
			InputsNames[2] = "Input C";
			InputsNames[3] = "Input D";
			InputsNames[4] = "Input E";
			InputsNames[5] = "Input F";
			InputsNames[6] = "Input G";
			InputsNames[7] = "Input H";
			InputsNames[8] = "Input I";
			InputsNames[9] = "Input J";
			InputsNames[10] = "Result";

			Refresh();

		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics myGraphics = e.Graphics;

			DrawStructure(ref myGraphics);

			performDraw(ref myGraphics);

			int totalCount = inputsCount + 1;
		}


		//======================================================
		//draw logic

		private void DrawStructure(ref Graphics myGraphics)
		{
			//draw the vertical line
			myGraphics.DrawLine(PenWhiteGro, 40, 0, 40, 350);

			int x1 = 40;
			int x2 = 30;
			int x3 = 400;
			int x4 = 30;
			for (int i = 0; i < tt.Rows.Count; i++)
			{
				myGraphics.DrawLine(PenWhiteGro, x1, x2, x3, x4);
				if ((i + 2) == tt.Rows.Count)
				{
					x2 += 40;
					x4 += 40;
				}
				else
				{
					x2 += 30;
					x4 += 30;
				}
			}
		}

		private void performDraw(ref Graphics myGraphics)
		{
			//variables
			PointF mainPoint = new PointF(50, 15);
			Pen currentPen;
			int x1 = 40;
			int y1 = 30;
			int x2 = 70;
			int y2 = 15;
			int counter = -1;

			int TotalCount = tt.Columns.Count;
			for (int i = 0; i < tt.Rows.Count; i++)
			{
				mainPoint = new PointF(50, (30 * i) + 15);
				//if (i == 2) return;

				//check if last row (result),make red pen
				int MainNextValue = i + 1;
				if (MainNextValue == (tt.Rows.Count))
					currentPen = penRed;
				else
					currentPen = penBlue;

				//drawing
				DataRow r = tt.Rows[i];
				for (int z = 1; z < tt.Columns.Count; z++)
				{

					int nextCounter = z + 1;

					int cellValue = Convert.ToInt32(r[z]);

					if (cellValue == 0) //draw false
					{
						myGraphics.DrawLine(currentPen, x1, y1, x2, y1);
						x1 = x2;
						myGraphics.DrawString(cellValue.ToString(), Font, brushBrown, mainPoint);
						if (currentPen == penRed)
						{
							Font a = new Font("Arial", 7);
							counter += 1;
							myGraphics.DrawString(counter.ToString(), a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)30.0));
							myGraphics.DrawString("*10^-9", a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)40.0));
							myGraphics.DrawString("ns", a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)50.0));
							myGraphics.DrawLine(penBlue, mainPoint.X, mainPoint.Y + 25, mainPoint.X, mainPoint.Y + 30);

						}


						if (nextCounter < (TotalCount))
						{
							int nextCellValue = Convert.ToInt32(r[z + 1]);
							if (nextCellValue == 1)
							{
								myGraphics.DrawLine(currentPen, x2, y1, x2, y2);
								myGraphics.DrawLine(currentPen, x1, y2, x2 + 30, y2);
								x1 = x2;
							}
						}
					}
					else
					{
						myGraphics.DrawLine(currentPen, x1, y2, x2, y2);
						x1 = x2;
						myGraphics.DrawString(cellValue.ToString(), Font, brushBrown, mainPoint);
						if (currentPen == penRed)
						{
							counter += 1;
							Font a = new Font("Arial", 7);
							myGraphics.DrawString(counter.ToString(), a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)30.0));
							myGraphics.DrawString("*10^-9", a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)40.0));
							myGraphics.DrawString("ns", a, brushBrown, new PointF((float)mainPoint.X - 5, (float)mainPoint.Y + (float)50.0));
							myGraphics.DrawLine(penBlue, mainPoint.X, mainPoint.Y + 25, mainPoint.X, mainPoint.Y + 30);
						}

						if (nextCounter < (TotalCount))
						{
							int nextCellValue = Convert.ToInt32(r[z + 1]);
							if (nextCellValue == 0)
							{
								myGraphics.DrawLine(currentPen, x2, y2, x2, y1);
								x1 = x2;
							}
						}
					}

					x2 = x1 + 30;
					mainPoint = new PointF(x2 - 15, y2);

				}


				//x2 = x1 + 30;
				x1 = 40;
				x2 = 70;
				y1 += 30;
				y2 += 30;
				//end of drawing
			} //end of main for
		} // end of procedure

		public void SetResult(string text)
		{
			lblResult.Text = text;
		}

		public void SetData(object data)
		{
			dataGridView1.DataSource = data;
		}


		public DataTable dT;
		public DataTable tt;
		//waveform variables
		public int inputsCount;

		private int[] a = new int[] { 0, 1, 0, 1 };
		private int[] b = new int[] { 0, 0, 1, 1 };
		private int[] res = new int[4];
		public static int colunm = 0;
		public Random r = new Random();


		Pen penBlue = new Pen(Color.Blue, 3);
		Pen penRed = new Pen(Color.Red, 3);
		Pen peGray = new Pen(Color.Gray, 3);
		Pen PenWhiteGro = new Pen(Color.White);
		SolidBrush brushBrown = new SolidBrush(Color.Brown);
		string[] InputsNames = new string[11];


		PointF[] myPoint = new PointF[11];
		PointF[] PointLoc = new PointF[11];
	}
}
