//
// Copyright (c) 2012, MindFusion LLC - Bulgaria.
//

using System;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MindFusion.Diagramming.WinForms.Samples.CS.LogicGates
{
	using Convert = System.Convert;

	/// <summary>
	/// Business Logic Layer Class.
	/// </summary>
	public class clsBLL
	{
		public static DataTable BuildTransactionTable()
		{
			DataTable t = new DataTable();
			DataColumn c;

			c = new DataColumn();
			c.ColumnName = "FirstSourceID";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "SecondSourceID";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "FirstSourceType";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "SecondSourceType";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "DestinationID";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "DestinationType";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "CurrentID";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "CurrentType";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "OutputResult";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "FirstInput";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "SecondInput";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "StarterID";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "BoxText";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);


			return t;

		} //end of building the table	
			
		
		//truth table variable

		public static DataTable BuildTruthTable()
		{
			DataTable t = new DataTable();
			DataColumn c;

			c = new DataColumn();
			c.ColumnName = "Input1";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input2";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input3";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input4";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input5";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input6";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input7";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input8";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input9";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Input10";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);

			c = new DataColumn();
			c.ColumnName = "Result";
			c.DataType = Type.GetType("System.String");
			t.Columns.Add(c);



			return t;
		}

		public static string GetNodeName(int index)
		{

			switch (index)
			{
				case 0: //and
				{ return "AND"; }
				case 1: //nand
				{ return "NAND"; }
				case 2: //nor
				{ return "NOR"; }
				case 3: //not
				{ return "NOT"; }
				case 4: //or
				{ return "OR"; }
				case 5: //xnor
				{ return "XNOR"; }
				case 6: //xor
				{ return "XOR"; }
				case 7: //circuit
				{ return "CIRCUIT"; }
				case 8: //start 0
				{ return "START 0"; }
				case 9: //start 1
				{ return "START 1"; }
				case 10: //terminator 
				{ return "END"; }
				default:
					return "Nothing";
			}
		}



		public static AnchorPattern CreatePattern(int index)
		{
			AnchorPattern apa = new AnchorPattern();
			AnchorPoint apo1;
			AnchorPoint apo2;
			AnchorPoint apo3;
			switch (index)
			{
				case 0: //and
				{
					apo1 = new AnchorPoint(0, 25, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 57, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 42, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 1: //nand
				{
					apo1 = new AnchorPoint(0, 30, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 61, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 46, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 2: //nor
				{
					apo1 = new AnchorPoint(0, 29, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 60, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 45, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 3: //not
				{
					apo1 = new AnchorPoint(0, 45, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(89, 45, false, true, MarkStyle.Circle, Color.Green);
                       
					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
                       
					return apa;
				}
				case 4: //or
				{
					apo1 = new AnchorPoint(0, 27, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 59, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 44, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 5: //xnor
				{
					apo1 = new AnchorPoint(0, 27, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 59, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 44, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 6: //xor
				{
					apo1 = new AnchorPoint(0, 27, true, false, MarkStyle.Circle, Color.Red);
					apo2 = new AnchorPoint(0, 59, true, false, MarkStyle.Circle, Color.Red);
					apo3 = new AnchorPoint(89, 44, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
					apa.Points.Add(apo2);
					apa.Points.Add(apo3);
					return apa;
				}
				case 7: //circuit
				{
					apo1 = new AnchorPoint(89, 22, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
                     
					return apa;
				}
				case 8: //start 0
				{
					apo1 = new AnchorPoint(89, 43, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
                      
					return apa;
				}
				case 9: //start 1
				{
					apo1 = new AnchorPoint(89, 43, false, true, MarkStyle.Circle, Color.Green);

					apa.Points.Add(apo1);
                     
					return apa;
				}
				case 10: //terminator 
				{
					apo1 = new AnchorPoint(0, 43, true, false, MarkStyle.Circle, Color.Red);
                    

					apa.Points.Add(apo1);
                       
					return apa;
				}
				default: return null;
			}

		}
	
	
		//check weather the box is properly linked
		public static bool IsBoxProperlyLinked(int type, int incomingCount, int outgoingCount)
		{
			switch (type)
			{
				case 0: //and
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 1: //nand
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 2: //nor
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 3: //not
				{
					if (incomingCount == 1 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 4: //or
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 5: //xnor
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 6: //xor
				{
					if (incomingCount == 2 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 7: //circuit
				{
					if (incomingCount == 0 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 8: //start 0
				{
					if (incomingCount == 0 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 9: //start 1
				{
					if (incomingCount == 0 && outgoingCount == 1)
						return true;
					else
						return false;
				}
				case 10: //terminator 
				{
					if (incomingCount == 1 && outgoingCount == 0)
						return true;
					else
						return false;
				}
				default: return false;
			}
        
		}


		public static int CircuitResultBuilder(ref DataTable dT)
		{
			for (int i = 0; i < dT.Rows.Count; i++)
			{
                
				FillResult( i, ref dT);
              
			}
			return CircuitOutputFinder(ref dT);
		}

		private static int CircuitOutputFinder(ref DataTable dT)
		{
			for (int i = 0; i < dT.Rows.Count; i++)
			{
				DataRow r = dT.Rows[i];

				int CurrentType = Convert.ToInt32(r[7]);
				int OutputResult = Convert.ToInt32(r[8]);
				if (CurrentType == 10)
				{
					return OutputResult;
				}

			}
			return -1; //nothing is found
		}

		public static int circuitBoxResult(int SourceID,ref DataTable dT)
		{
			for (int i = 0; i < dT.Rows.Count; i++)
			{
				DataRow r = dT.Rows[i];

				int CurrentID = Convert.ToInt32(r[6]);
				int OutputResult = Convert.ToInt32(r[8]);
				if (CurrentID == SourceID)
				{
					return OutputResult;
				}
			}
			return -15;
           
		}

		public static void FillResult(int i,ref DataTable dT)
		{
			DataRow r= dT.Rows[i];

			int FirstSourceID=Convert.ToInt32(r[0]);
			int SecondSourceID=Convert.ToInt32(r[1]);
			int FirstSourceType=Convert.ToInt32(r[2]);
			int SecondSourceType=Convert.ToInt32(r[3]);
			int DestinationID=Convert.ToInt32(r[4]);
			int DestinationType=Convert.ToInt32(r[5]);
			int CurrentID=Convert.ToInt32(r[6]);
			int CurrentType=Convert.ToInt32(r[7]);
			int OutputResult=Convert.ToInt32(r[8]);
			int FirstInput=Convert.ToInt32(r[9]);
			int SecondInput=Convert.ToInt32(r[10]);
			int starterID = (r["StarterID"] is System.DBNull ? -15 : Convert.ToInt32(r["StarterID"]));
			string BoxText = r["BoxText"].ToString();

			bool bFirstInput=Convert.ToBoolean(Math.Abs(Convert.ToInt32(r[9])));
			bool bSecondInput = Convert.ToBoolean(Math.Abs(Convert.ToInt32(r[10])));
			bool result;

			if (CurrentType==7 || CurrentType == 8 || CurrentType == 9) //don't do anything for 0 & 1
				return;
			if (( FirstSourceType == 8 || FirstSourceType == 9) )
			{
				r.BeginEdit();
				r["FirstInput"] = Convert.ToInt32(GetTypeValue(FirstSourceType));
				r.EndEdit();
			}
			else if (FirstSourceType == 7)
			{
				r.BeginEdit();
				r["FirstInput"] = circuitBoxResult(FirstSourceID,ref dT);
				r.EndEdit();
                
			}

			if ( ( SecondSourceType == 8 || SecondSourceType == 9))
			{
				r.BeginEdit();
				r["SecondInput"] = Convert.ToInt32(GetTypeValue(SecondSourceType));
				r.EndEdit();
			}
			else if (SecondSourceType == 7)
			{
				r.BeginEdit();
				r["SecondInput"] = circuitBoxResult(SecondSourceID,ref dT);
				r.EndEdit();
			}

			if ((FirstSourceType == 7 || FirstSourceType == 8 || FirstSourceType == 9) && (SecondSourceType == 7 || SecondSourceType == 8 || SecondSourceType == 9))
			{
				result=DoBuild(CurrentType, FirstSourceType, SecondSourceType, i,ref dT,FirstSourceID,SecondSourceID);
				UpdateCurrentOutputInOtherRecords(  ref dT,CurrentID,result);
			}
			else if ((CurrentType == 3 || CurrentType == 10) && (FirstSourceType == 7 || FirstSourceType == 8 || FirstSourceType == 9))
			{
				result = DoBuild(CurrentType, FirstSourceType, SecondSourceType, i, ref dT,FirstSourceID,SecondSourceID);
				UpdateCurrentOutputInOtherRecords(ref dT, CurrentID, result);
			}
			else if(((CurrentType==3 || CurrentType==10) && FirstInput!=-15)||(FirstInput!=-15 && SecondInput!=-15))
			{
				result = DoBuild(CurrentType, bFirstInput, bSecondInput,i, ref dT);
                
				UpdateCurrentOutputInOtherRecords(ref dT, CurrentID, result);
          
			}
			else //calculate my prefixes and then me
			{
				int FirstRequiredRowNumber=0;
				int SecondRequiredRowNumber=0;
                
				for (int m = 0; m < dT.Rows.Count; m++)
				{
					int CheckCurrentID=Convert.ToInt32(dT.Rows[m]["CurrentID"]);
					if (CheckCurrentID == FirstSourceID)
						FirstRequiredRowNumber = m;
					if (CheckCurrentID == SecondSourceID)
						SecondRequiredRowNumber = m;

				}

				//calculate first
				if (CurrentType==3 || CurrentType==10) //not or terminator
				{
					//required only first
					FillResult(FirstRequiredRowNumber  ,ref dT);
					FillResult(i  ,ref dT); //or this
					//result = DoBuild(CurrentType, bFirstInput, bSecondInput,i, ref dT);
					//UpdateCurrentOutputInOtherRecords(ref dT, CurrentID, result);

               
				}
				else //others
				{
					//required first and second
					if (!( FirstSourceType==7 || FirstSourceType==8 || FirstSourceType==9))
						FillResult(FirstRequiredRowNumber  ,ref dT);
					if (!(SecondSourceType == 7 || SecondSourceType == 8 || SecondSourceType == 9))
						FillResult(SecondRequiredRowNumber  ,ref dT);
                    
					FillResult(i  ,ref dT); //or this
				}
                    

			} //end of else

		}

		public static bool DoBuild(int CurrentType,int FirstSourceType, int SecondSourceType,int i, ref DataTable dT,int FirstSourceID,int SecondSourceID)
		{
			DataRow r = dT.Rows[i];
			bool FirstResult,SecondResult;
			if (FirstSourceType==7)
			{
				FirstResult=Convert.ToBoolean(circuitBoxResult(FirstSourceID,ref dT));
			}
			else
			{
				FirstResult=GetTypeValue(FirstSourceType);
			}
			if (SecondSourceType==7)
			{
				SecondResult=Convert.ToBoolean(circuitBoxResult(SecondSourceID,ref dT));
			}
			else
			{
				SecondResult = GetTypeValue(SecondSourceType);
			}
                
                
			bool result = OperationBuilder(CurrentType, FirstResult, SecondResult);
            
			r.BeginEdit();
			r["OutputResult"] = Convert.ToInt32(result); //r[8]
			r.EndEdit();
			return result;
		}


		public static bool DoBuild(int CurrentType, bool FirstSourceType, bool SecondSourceType, int i, ref DataTable dT)
		{
			DataRow r = dT.Rows[i];
			bool result = OperationBuilder(CurrentType, FirstSourceType, SecondSourceType);
			r.BeginEdit();
			r["OutputResult"] = Convert.ToInt32(result); //r[8]
			r.EndEdit();
			return result;
		}


		public static void UpdateCurrentOutputInOtherRecords(ref DataTable dT,int ParentCurrentID,bool result)
		{
			//store this result for other records
			for (int k = 0; k < dT.Rows.Count; k++)
			{
				DataRow d = dT.Rows[k];
				int FirstSourceID = Convert.ToInt32(d[0]);
				int SecondSourceID = Convert.ToInt32(d[1]);
				int CurrentID = Convert.ToInt32(d[6]);
            
                
          
				if (((FirstSourceID == ParentCurrentID) || (SecondSourceID == ParentCurrentID)) && (CurrentID != ParentCurrentID))
				{
					d.BeginEdit();
					if (FirstSourceID == ParentCurrentID)
						d[9] = Convert.ToInt32(result);
					if (SecondSourceID == ParentCurrentID)
						d[10] = Convert.ToInt32(result);
					d.EndEdit();

				}

			}        
        
        
		}

//here
		public static bool GetTypeValue(int ID)
		{
			switch (ID)
			{

				case 7: //circuit
				{ return true; }
				case 8: //start0
				{ return false; }
				case 9://start1
				{ return true; }
				default:
				{ return false; }
			}

		}


		public static bool OperationBuilder(int operation,bool first,bool second)
		{

			switch (operation)
			{

				case 0: //and
				{ return (first & second); }
				case 1: //nand
				{ return !(first & second); }
				case 2: //nor
				{ return !(first | second); }
				case 3: //not
				{ return !(first); }
				case 4: //or
				{ return (first | second); }
				case 5: //xnor
				{ return !(first ^ second); }
				case 6: //xor
				{ return (first ^ second); }
				case 10: //terminator, return it as it is
				{ return (first); }
				default:
					return false;
			}

            
		}


		public static int TruthTablePrepare(ref DataTable dT,ref DataTable Truth)
		{ 
         

			int inputsCounter=0;
			for (int i = 0; i < dT.Rows.Count; i++)
			{
				DataRow r = dT.Rows[i];

				int FirstSourceType = Convert.ToInt32(r[2]);
				int SecondSourceType = Convert.ToInt32(r[3]);

				if (FirstSourceType == 8 || FirstSourceType == 9)
					inputsCounter += 1;

				if (SecondSourceType == 8 || SecondSourceType == 9)
					inputsCounter += 1;
			}

			DataRow dr=null;
			TruthTableBuilder(1, inputsCounter,ref Truth,ref dr);

			//calculate result
			for (int k = 0; k < Truth.Rows.Count; k++)
			{
				int currentCount = 0;
				DataRow Tr = Truth.Rows[k];
				for (int i = 0; i < dT.Rows.Count; i++)
				{
					DataRow rrr=dT.Rows[i];
					rrr.BeginEdit();
					rrr["OutputResult"] = -15;
					rrr["FirstInput"] = -15;
					rrr["SecondInput"] = -15;
					rrr.EndEdit();
					int CurrentType = Convert.ToInt32(rrr[7]);

					if (CurrentType == 8 || CurrentType == 9)
					{
						rrr.BeginEdit();
						int tmp = Convert.ToInt32(Tr[currentCount]);
						int newNodeType;
						if (tmp == 0)
						{
							rrr[7] = 8;
							newNodeType = 8;
						}
						else
						{
							rrr[7] = 9;
							newNodeType = 9;
						}
						rrr.EndEdit();
						int currentNodeID = Convert.ToInt32(rrr["CurrentID"]);
						updateAsSource(ref dT,currentNodeID,newNodeType);
						currentCount += 1;
					}
				}
				//get result
				int finalResult = clsBLL.CircuitResultBuilder(ref dT);
				Tr.BeginEdit();
				Tr["Result"] = finalResult;
				Tr.EndEdit();
			}
			reverser(ref Truth,inputsCounter);
			BuildReverseTable(inputsCounter);

			return inputsCounter;
		}

		public static DataTable GeneratedTruthTable;
		public static char[,] tmpTruthTable = new char[11, 1024];
		private static void BuildReverseTable(int inputsCounter)
		{
			//calculate possibilities=number of columns
			//inputscount+ 1 for result=number of rows
			int possibilities = (int)Math.Pow(2.0, (double)inputsCounter);
			int generatedRowsCount = inputsCounter + 1;

			//build columns
			GeneratedTruthTable = null;
			GeneratedTruthTable = new DataTable();

			for (int q = 0; q <= possibilities; q++)
			{
				DataColumn c = new DataColumn();
				c.ColumnName = (q+1).ToString();
				c.DataType = Type.GetType("System.String");
				GeneratedTruthTable.Columns.Add(c);
			}

			//now the generation
			for (int w = 0; w < generatedRowsCount; w++)
			{
				DataRow r = GeneratedTruthTable.NewRow();
				r.BeginEdit();
				if ((w + 1)== generatedRowsCount)
					r[0] = "Result";
				else
					r[0] = "Input " + (w + 1).ToString();
				for (int q = 1; q <= possibilities; q++)
				{
					char val = tmpTruthTable[w, q - 1];
					r[q] = val;
				}
				r.EndEdit(); 
				GeneratedTruthTable.Rows.Add(r);
       
			}



		}



		private static void reverser(ref DataTable Truth, int inputsCounter)
		{
			for (int i = 0; i < Truth.Rows.Count; i++)
			{
				for (int k = 0; k < Truth.Columns.Count; k++)
				{
					int t = Convert.ToInt32(Truth.Rows[i][k]);
					int n = k + 1;
					int generatedRowsCount = inputsCounter;
					if (n == Truth.Columns.Count)
						tmpTruthTable[generatedRowsCount, i] = Convert.ToChar(t.ToString());
					else
						tmpTruthTable[k, i] = Convert.ToChar(t.ToString());

				}
			}
		}


		private static void updateAsSource(ref DataTable dT, int currentNodeID,int newNodeType)
		{
			for (int i = 0; i < dT.Rows.Count; i++)
			{
				DataRow r = dT.Rows[i];
				int FirstSourceID = Convert.ToInt32(r[0]);
				int SecondSourceID = Convert.ToInt32(r[1]);
				int FirstSourceType = Convert.ToInt32(r[2]);
				int SecondSourceType = Convert.ToInt32(r[3]);
              
				if (FirstSourceID == currentNodeID)
				{
					r.BeginEdit();
					r["FirstSourceType"] = newNodeType;
					r.EndEdit();
				}
				if (SecondSourceID== currentNodeID)
				{
					r.BeginEdit();
					r["SecondSourceType"] = newNodeType;
					r.EndEdit();
				}
			}
		}



    
		public static void initializeTmpArray()
		{
			tmpArray[0]=-1;
			tmpArray[1]=-1;
			tmpArray[2]=-1;
			tmpArray[3]=-1;
			tmpArray[4]=-1;
			tmpArray[5]=-1;
			tmpArray[6]=-1;
			tmpArray[7]=-1;
			tmpArray[8]=-1;
			tmpArray[9]=-1;
        
		}

		private static int[] tmpArray=new int[10];
		public static void TruthTableBuilder(int currentCount,int inputsCounter, ref DataTable Truth,ref DataRow dr)
		{
			for (int i = 0; i <= 1; i++)
			{
				tmpArray[currentCount - 1 ] = i;
				//store in table
				if (i == 1 || currentCount == 1)
				{
					DataRow r = Truth.NewRow();
					r.BeginEdit();
					r[0]=tmpArray[0] ;
					r[1]=tmpArray[1] ;
					r[2]=tmpArray[2] ;
					r[3]=tmpArray[3] ;
					r[4]=tmpArray[4] ;
					r[5]=tmpArray[5] ;
					r[6]=tmpArray[6] ;
					r[7]=tmpArray[7] ;
					r[8]=tmpArray[8] ;
					r[9]=tmpArray[9] ;
					r.EndEdit();
					Truth.Rows.Add(r);
					dr = r; 
				}
				else if (currentCount==inputsCounter)
				{
					dr.BeginEdit();
					dr[0] = tmpArray[0];
					dr[1] = tmpArray[1];
					dr[2] = tmpArray[2];
					dr[3] = tmpArray[3];
					dr[4] = tmpArray[4];
					dr[5] = tmpArray[5];
					dr[6] = tmpArray[6];
					dr[7] = tmpArray[7];
					dr[8] = tmpArray[8];
					dr[9] = tmpArray[9];
					dr.EndEdit();
              
				}

				if (currentCount != inputsCounter)
				{
					TruthTableBuilder(currentCount + 1,inputsCounter,ref Truth, ref dr);
				}
			}

		}

		public static int circuitCalculator(ref Diagram fcx)
		{
			DataTable dT = null;
			dT = clsBLL.BuildTransactionTable();


			foreach (ShapeNode bo in fcx.Nodes)
			{
				string[] s = bo.Tag.ToString().Split('|');
				DiagramLinkCollection iac = bo.IncomingLinks;
				DiagramLinkCollection oac = bo.OutgoingLinks;

				if (clsBLL.IsBoxProperlyLinked(Convert.ToInt32(s[0]), iac.Count, oac.Count) == true)
				{
					DataRow r = dT.NewRow();
					if (iac.Count == 0)
					{
						r["FirstSourceID"] = -15;
						r["SecondSourceID"] = -15;
						r["FirstSourceType"] = -15;
						r["SecondSourceType"] = -15;
					}
					else if (iac.Count == 1)
					{
						string[] r1 = iac[0].Origin.Tag.ToString().Split('|');
						r["FirstSourceID"] = r1[1];
						r["SecondSourceID"] = -15;
						r["FirstSourceType"] = r1[0];
						r["SecondSourceType"] = -15;
					}
					else if (iac.Count == 2)
					{
						string[] r2 = iac[0].Origin.Tag.ToString().Split('|');
						string[] r3 = iac[1].Origin.Tag.ToString().Split('|');
						r["FirstSourceID"] = r2[1];
						r["SecondSourceID"] = r3[1];
						r["FirstSourceType"] = r2[0];
						r["SecondSourceType"] = r3[0];
					}

					if (oac.Count == 0)
					{
						r["DestinationID"] = -15;
						r["DestinationType"] = -15;
					}
					else if (oac.Count == 1)
					{
						string[] r4 = oac[0].Destination.Tag.ToString().Split('|');
						r["DestinationID"] = r4[1];
						r["DestinationType"] = r4[0];
					}

					r["CurrentID"] = s[1];
					r["CurrentType"] = s[0];
					r["OutputResult"] = -15;
					r["FirstInput"] = -15;
					r["SecondInput"] = -15;
					r["BoxText"] = bo.Text;
					int boxNodeType = Convert.ToInt32(s[0]);
					if (boxNodeType == 8 || boxNodeType == 9)
					{

						r["StarterID"] = bo.Text.Substring(0, 1);
					}
					dT.Rows.Add(r);
				}
				else
				{
					MessageBox.Show("Incorrect Circuit File, Please Choose another file");
					return -15;
				}

			} //end of for

			//clsBLL.BuildOutput(ref dT);
			int finalResult = clsBLL.CircuitResultBuilder(ref dT);
			return finalResult;
            
		}
	}//end of class
}
